#ifndef LCRZOEX_H_INCLUDED
#define LCRZOEX_H_INCLUDED 1

/* This file includes the necessary system includes */

/* check the library version */
#include "lcrzoex_verifversion.h"

/* include system includes */
#ifdef LCRZODEF_SYSTEM_Linux
 /* Linux */
 #if ! defined _GNU_SOURCE
  #define _GNU_SOURCE 1
 #endif
 #if ! defined _POSIX_SOURCE
  #define _POSIX_SOURCE 1
 #endif
 #include <stdlib.h>
 #include <stdio.h>
 #include <time.h>
 #include <unistd.h> 
 #include <dirent.h>
 #include <ctype.h>
 #include <errno.h>
 #include <string.h>
 #include <signal.h>
 #include <sys/types.h>
 #include <sys/stat.h>
 #include <sys/wait.h>

#elif defined LCRZODEF_SYSTEM_FreeBSD
 /* FreeBSD */
 #include <stdlib.h>
 #include <stdio.h>
 #include <time.h>
 #include <unistd.h> 
 #include <dirent.h>
 #include <ctype.h>
 #include <errno.h>
 #include <string.h>
 #include <signal.h>
 #include <sys/types.h>
 #include <sys/stat.h>
 #include <sys/wait.h>

#elif defined LCRZODEF_SYSTEM_Solaris
 /* Solaris */
 #if ! defined __EXTENSIONS__
  #define __EXTENSIONS__ 1
 #endif
 #include <stdlib.h>
 #include <stdio.h>
 #include <time.h>
 #include <unistd.h> 
 #include <dirent.h>
 #include <ctype.h>
 #include <errno.h>
 #include <string.h>
 #include <signal.h>
 #include <sys/types.h>
 #include <sys/stat.h>
 #include <sys/wait.h>

#else
 #error "Bad LCRZODEF_SYSTEM"
#endif


#endif
