
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"
#include "shared/shared_sniff.h"

/*-------------------------------------------------------------*/
/* set information about this example */
lcrzoex_infos lcrzoex_000011=
{ /*reference*/     "lcrzoex", 11,
  /*version*/       1, 0,
  /*title*/         "sniff packets (IP reas.) and save them in an Eth record",
  /*french title*/  "sniffe des paquets (reas. IP) et les sauve dans un record Eth",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "file [device [\"bpf_filter\"]]",
  /*french usage*/  "fichier [device [\"filtre_bpf\"]]",
  /*usage example*/ "/tmp/file eth0 \"host 1.2.3.4 and port 25\"",
  /*fr. usage ex.*/ "/tmp/fichier eth0 \"host 1.2.3.4 and port 25\"", 
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declaration */
int lcrzoex_000011_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000011_main(int argc, char *argv[])
{
  if ( argc<2 )
  { /* print usage */
    lcrzo_epr(lcrzoex_infos_print(lcrzoex_000011, argv[0]));
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }

  lcrzo_epr(shared_sniff_dumpsaveeth(argc, argv, LCRZO_SNIFF_TYPE_IPREAS));

  return(LCRZO_ERR_OK);
}
