
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
lcrzoex_infos lcrzoex_000027=
{ /*reference*/     "lcrzoex", 27,
  /*version*/       1, 0,
  /*title*/         "IP record :   display",
  /*french title*/  "IP record :   affiche",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "file [startpacket [endpacket]]",
  /*french usage*/  "nom_fichier [packet_debut [packet_fin]]",
  /*usage example*/ "/tmp/file 1 6",
  /*fr. usage ex.*/ "/tmp/fichier 1 6", 
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declaration */
int lcrzoex_000027_main(int argc, char *argv[]);
int lcrzoex_000027_printipdata(lcrzo_constdata data,
			       lcrzo_int32 datasize,
			       void *pinfos);

/*-------------------------------------------------------------*/
/* variable declaration */
lcrzo_printprofile lcrzoex_000027printprofile;

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000027_main(int argc, char *argv[])
{ lcrzo_int32 start, end;
  lcrzo_record record;
  int language;

  if ( argc<2 )
  { /* print usage */
    lcrzo_epr(lcrzoex_infos_print(lcrzoex_000027, argv[0]));
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }
  if (argc>=3) start=atol(argv[2]); else start=+1;
  if (argc>=4) end=atol(argv[3]); else end=-1;

  /* open the record */
  lcrzo_epr(lcrzo_record_open(&record, argv[1], LCRZO_RECORD_OPEN_READ));

  /* get printprofile */
  lcrzo_epr(lcrzo_global_get_language(&language));
  lcrzo_epr(lcrzo_printprofile_stdin((language==LCRZO_GLOBAL_FRLANG)?
				     "Choisissez le profil d'affichage":
				     "Choose the print profile",
				     LCRZO_PRINTPROFILE_ARRAYDUMP, 
				     &lcrzoex_000027printprofile));

  /* main loop */
  lcrzo_epr(lcrzo_record_loop_range(&record, start, end,
				    &lcrzoex_000027_printipdata, NULL));

  /* end */
  lcrzo_epr(lcrzo_record_close(&record));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000027_printipdata(lcrzo_constdata data,
			       lcrzo_int32 datasize,
			       void *pinfos)
{
  lcrzo_epr(lcrzo_packet_print_ip(data, datasize,
				  lcrzoex_000027printprofile));
  if (lcrzoex_000027printprofile.hdr!=LCRZO_PRINTTYPE_SYNTH) printf("\n");
  return (LCRZO_ERR_OK);
}

