
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
lcrzoex_infos lcrzoex_000066=
{ /*reference*/     "lcrzoex", 66,
  /*version*/       1, 0,
  /*title*/         "{IP,ICMP} spoof specified by command line",
  /*french title*/  "spoof {IP,ICMP} specifie sur la ligne de commande",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "ip_source_address ip_dest_address type code",
  /*french usage*/  "adresse_ip_source adresse_ip_dest type code",
  /*usage example*/ "1.2.3.4 5.6.7.8 8 0",
  /*fr. usage ex.*/ "1.2.3.4 5.6.7.8 8 0", 
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000066_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000066_main(int argc, char *argv[])
{ lcrzo_data data;
  lcrzo_int32 datasize;
  lcrzo_spoof spoof;
  int language;
  lcrzo_hdrlip hdrlip;
  lcrzo_hdrlicmp hdrlicmp;
  lcrzo_ipopt ipopt;
  lcrzo_uint8 ipoptsize;

  if ( argc<5 )
  { /* print usage */
    lcrzo_epr(lcrzoex_infos_print(lcrzoex_000066, argv[0]));
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }

  /* get language */
  lcrzo_epr(lcrzo_global_get_language(&language));

  /* initialize IP header */
  lcrzo_epr(lcrzo_hdrlip_initdefault(&hdrlip));
  lcrzo_epr(lcrzo_ipl_init_hs(argv[1], &(hdrlip.saddr)));
  lcrzo_epr(lcrzo_ipl_init_hs(argv[2], &(hdrlip.daddr)));

  /* initialize IP options */
  lcrzo_epr(lcrzo_ipopt_stdin((language==LCRZO_GLOBAL_FRLANG)?
			      "options IP":"IP options", "",
			      ipopt, &ipoptsize));

  /* initialize ICMP header */
  lcrzo_epr(lcrzo_hdrlicmp_initdefault(&hdrlicmp));
  hdrlicmp.type=(lcrzo_uint8)atoi(argv[3]);
  hdrlicmp.code=(lcrzo_uint8)atoi(argv[4]);

  /* initialize data */
  lcrzo_epr(lcrzo_data_initm_mixed_stdin((language==LCRZO_GLOBAL_FRLANG)?
					 "donnees du paquet":"packet's data",
					 "'hello' 0D0A", &data, &datasize));

  /* spoof */
  lcrzo_epr(lcrzo_spoof_init(&spoof));
  lcrzo_epr(lcrzo_spoof_set_printbeforesending(&spoof, LCRZO_TRUE));
  lcrzo_epr(lcrzo_spoof_ipopticmpdata(&spoof, hdrlip, ipopt, ipoptsize,
				     hdrlicmp, data, datasize));
  lcrzo_epr(lcrzo_spoof_close(&spoof));

  lcrzo_data_free(data);
  return(LCRZO_ERR_OK);
}
