
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"
#include "shared/shared_syslog.h"

/*-------------------------------------------------------------*/
/* set information about this example */
lcrzoex_infos lcrzoex_000088=
{ /*reference*/     "lcrzoex", 88,
  /*version*/       1, 1,
  /*title*/         "real udp client [syslog]",
  /*french title*/  "client udp reel [syslog]",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "server_name server_port",
  /*french usage*/  "nom_serveur port_serveur",
  /*usage example*/ "1.2.3.5 4444",
  /*fr. usage ex.*/ "1.2.3.5 4444",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000088_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000088_main(int argc, char *argv[])
{ lcrzo_ipl ipl;
  lcrzo_sock sock;

  if ( argc<3 )
  { /* print usage */
    lcrzo_epr(lcrzoex_infos_print(lcrzoex_000088, argv[0]));
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }

  lcrzo_epr(lcrzo_ipl_init_hs(argv[1], &ipl));
  lcrzo_epr(lcrzo_sock_udpcli_real(ipl, (lcrzo_uint16)atoi(argv[2]), &sock));
  lcrzo_epr(shared_syslog_sockdatehexa(&sock, 17, "Lcrzo"));
  lcrzo_epr(lcrzo_sock_close(&sock));

  return(LCRZO_ERR_OK);
}

