
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"
#include "shared/shared_ftp.h"

/*-------------------------------------------------------------*/
/* set information about this example */
lcrzoex_infos lcrzoex_000106=
{ /*reference*/     "lcrzoex", 106,
  /*version*/       1, 0,
  /*title*/         "real tcp client [passive ftp]",
  /*french title*/  "client tcp reel [ftp passif]",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "cliname sername cliport serport clidataport file",
  /*french usage*/  "nomcli nomserv portcli portserv portdonneescli fichier",
  /*usage example*/ "1.2.3.4 1.2.3.5 6666 21 7777 /etc/hosts",
  /*fr. usage ex.*/ "1.2.3.4 1.2.3.5 6666 21 7777 /etc/hosts",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000106_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000106_main(int argc, char *argv[])
{ lcrzo_ipl clientipl, serveripl;
  lcrzo_uint16 clientport, serverport, clientdataport, serverdataport;
  lcrzo_sock controlsock, datasock;
  int pid, ret, status;

  if ( argc<7 )
  { /* print usage */
    lcrzo_epr(lcrzoex_infos_print(lcrzoex_000106, argv[0]));
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }

  /* initialize IP addresses */
  lcrzo_epr(lcrzo_ipl_init_hs(argv[1], &clientipl));
  lcrzo_epr(lcrzo_ipl_init_hs(argv[2], &serveripl));

  /* initialize ports */
  clientport=(lcrzo_uint16)atoi(argv[3]);
  serverport=(lcrzo_uint16)atoi(argv[4]);
  clientdataport=(lcrzo_uint16)atoi(argv[5]);

  /* initialize control connection */
  lcrzo_epr(lcrzo_sock_tcpcli_real2(clientipl, serveripl,
				    clientport, serverport, 
				    NULL, 0, &controlsock));

  /* obtains server data port */
  lcrzo_epr(shared_ftp_pass_contbegin(&controlsock,
				      &serveripl,
				      &serverdataport));
  lcrzo_ipl_print("Server IP : ", serveripl, "\n");
  printf("Server port : %d\n", serverdataport);

  /* initialize data connection, and listen (in a child process) */
  pid=fork();
  if (pid<0) return(LCRZO_ERR_FUFORK);
  if (pid==0)
  { ret=lcrzo_sock_tcpcli_real2(clientipl, serveripl, 
				clientdataport, serverdataport, NULL, 0,
				&datasock);
    if ( ret!=LCRZO_ERR_OK ) { lcrzo_err_print(ret); _exit(ret); }
    shared_ftp_pass_data(&datasock);
    /* never reatched */
  }

  /* requests the file */
  lcrzo_epr(shared_ftp_pass_contend(&controlsock, argv[6]));

  /* kill the child */
  ret=kill(pid, SIGINT);
  if (ret==-1) return(LCRZO_ERR_FUKILL);
  ret=waitpid(pid, &status, 0);
  if (ret==-1) return(LCRZO_ERR_FUWAITPID);

  return (LCRZO_ERR_OK);
}
