
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/* set information about this example */
lcrzoex_infos lcrzoex_000134=
{ /*reference*/     "lcrzoex", 134, 
  /*version*/       1, 0, 
  /*title*/         "print Ethernet addresses of computers on a network", 
  /*french title*/  "affiche les adresses Ethernet des machines d'un reseau", 
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "w.x.y.z (class C if z==0, class B if y==z==0)",
  /*french usage*/  "w.x.y.z (classe C si z==0, classe B si y==z==0)", 
  /*usage example*/ "192.168.1.0",
  /*fr. usage ex.*/ "192.168.1.0",
  /*author*/        "Laurent"
};

/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000134_main(int argc, char *argv[]);
int lcrzoex_000134_main(int argc, char *argv[])
{ lcrzo_ipa ipa;
  lcrzo_etha etha;
  lcrzo_uint8 i, j;
  int ret;

  if ( argc<2 )
  { /* print usage */
    lcrzo_epr(lcrzoex_infos_print(lcrzoex_000134, argv[0]));
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }

  lcrzo_epr(lcrzo_ipa_init_ips(argv[1], ipa));
  if ( ipa[2]==0 && ipa[3]==0 )
  { for ( i=1 ; i<=254 ; i++ )
      for ( j=1 ; j<=254 ; j++ )
      { ipa[2]=i;
        ipa[3]=j;
	lcrzo_ipa_print("", ipa, "");
        ret=lcrzo_etha_init_ipa(ipa, etha);
	if (ret==LCRZO_ERR_OK)
	  lcrzo_etha_print("\t", etha, "\n");
	else
	  puts("");
      }
  }
  else if ( ipa[3]==0 )
  { for ( i=1 ; i<=254 ; i++ )
    { ipa[3]=i;
      lcrzo_ipa_print("", ipa, "");
      ret=lcrzo_etha_init_ipa(ipa, etha);
      if (ret==LCRZO_ERR_OK)
        lcrzo_etha_print("\t", etha, "\n");
      else
	puts("");
    }
  }
  else
  { ret=lcrzo_etha_init_ipa(ipa, etha);
    lcrzo_ipa_print("", ipa, "");
    if (ret==LCRZO_ERR_OK)
      lcrzo_etha_print("\t", etha, "\n");
    else
      puts("");
  }
  return(LCRZO_ERR_OK);
}
