
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"
#include "shared/shared_smtp.h"

/*-------------------------------------------------------------*/
/* set information about this example */
lcrzoex_infos lcrzoex_000166=
{ /*reference*/     "lcrzoex", 166,
  /*version*/       1, 2,
  /*title*/         "real tcp client [send spoofed email]",
  /*french title*/  "client tcp reel [envoie email spoofe]",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "server_name server_port 'mailfrom@a.b' 'rcptto@c.d' 'from@a.b' 'replyto@e.f' 'to@c.d' body_filename ['subject']",
  /*french usage*/  "nom_serveur port_serveur 'mailfrom@a.b' 'rcptto@c.d' 'from@a.b' 'replyto@e.f' 'to@c.d' fichier_body ['sujet']",
  /*usage example*/ "1.2.3.4 25 'laurent@s.com' 'dest@d.com' 'laur@s.com' 'l@s.com' 'dest@d.com' /tmp/file 'here the subject'",
  /*fr. usage ex.*/ "1.2.3.4 25 'laurent@s.com' 'dest@d.com' 'laur@s.com' 'l@s.com' 'dest@d.com' /tmp/fichier 'ici, le sujet'",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000166_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000166_main(int argc, char *argv[])
{ lcrzo_ipl ipl;

  if ( argc<9 )
  { /* print usage */
    lcrzo_epr(lcrzoex_infos_print(lcrzoex_000166, argv[0]));
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }

  lcrzo_er(lcrzo_ipl_init_hs(argv[1], &ipl));
  lcrzo_er(shared_smtp_sendamail(ipl, (lcrzo_uint16)atoi(argv[2]),
				 argv[3], argv[4], argv[5], argv[6],argv[7],
				 (argc==9)?"":argv[9], argv[8]));

  return(LCRZO_ERR_OK);
}

