
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
lcrzoex_infos lcrzoex_000205=
{ /*reference*/     "lcrzoex", 205,
  /*version*/       1, 0,
  /*title*/         "{IP,TCP} spoof specified by command line (constant data, with fin)",
  /*french title*/  "spoof {IP,TCP} specifie sur la ligne de commande (donnees constantes, avec fin)",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "ip_source_address ip_dest_address source_port dest_port syn ack fin rst seqnum acknum",
  /*french usage*/  "adresse_ip_source adresse_ip_dest port_source port_dest syn ack fin rst seqnum acknum",
  /*usage example*/ "1.2.3.4 5.6.7.8 1234 21  1 1 0 0  43223 493484",
  /*fr. usage ex.*/ "1.2.3.4 5.6.7.8 1234 21  1 1 0 0  43223 493484", 
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000205_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000205_main(int argc, char *argv[])
{ lcrzo_data data;
  lcrzo_int32 datasize;
  lcrzo_spoof spoof;
  lcrzo_hdrlip hdrlip;
  lcrzo_hdrltcp hdrltcp;
  lcrzo_ipopt ipopt;
  lcrzo_tcpopt tcpopt;
  lcrzo_uint8 ipoptsize, tcpoptsize;

  if ( argc<11 )
  { /* print usage */
    lcrzo_epr(lcrzoex_infos_print(lcrzoex_000205, argv[0]));
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }

  /* initialize IP header */
  lcrzo_epr(lcrzo_hdrlip_initdefault(&hdrlip));
  lcrzo_epr(lcrzo_ipl_init_hs(argv[1], &(hdrlip.saddr)));
  lcrzo_epr(lcrzo_ipl_init_hs(argv[2], &(hdrlip.daddr)));

  /* initialize IP options */
  lcrzo_epr(lcrzo_ipopt_init_mixed("01 01 01 01", ipopt, &ipoptsize));

  /* initialize TCP header */
  lcrzo_epr(lcrzo_hdrltcp_initdefault(&hdrltcp));
  hdrltcp.sport=(lcrzo_uint16)atoi(argv[3]);
  hdrltcp.dport=(lcrzo_uint16)atoi(argv[4]);
  hdrltcp.syn=(lcrzo_uint8)atoi(argv[5]);
  hdrltcp.ack=(lcrzo_uint8)atoi(argv[6]);
  hdrltcp.fin=(lcrzo_uint8)atoi(argv[7]);
  hdrltcp.rst=(lcrzo_uint8)atoi(argv[8]);
  lcrzo_epr(lcrzo_uint32_init_text(argv[9], &hdrltcp.seqnum));
  lcrzo_epr(lcrzo_uint32_init_text(argv[10], &hdrltcp.acknum));

  /* initialize TCP options */
  lcrzo_epr(lcrzo_tcpopt_init_mixed("01 01 01 01", tcpopt, &tcpoptsize));

  /* initialize data */
  lcrzo_epr(lcrzo_data_initm_mixed("'hello' 0D0A", &data, &datasize));

  /* spoof */
  lcrzo_epr(lcrzo_spoof_init(&spoof));
  lcrzo_epr(lcrzo_spoof_set_printbeforesending(&spoof, LCRZO_TRUE));
  lcrzo_epr(lcrzo_spoof_ipopttcpoptdata(&spoof, hdrlip, ipopt, ipoptsize,
					hdrltcp, tcpopt, tcpoptsize,
					data, datasize));
  lcrzo_epr(lcrzo_spoof_close(&spoof));

  lcrzo_data_free(data);
  return(LCRZO_ERR_OK);
}
