
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"
#include "shared/shared_misc.h"

/*-------------------------------------------------------------*/
/* set information about this example */
lcrzoex_infos lcrzoex_000216=
{ /*reference*/     "lcrzoex", 216,
  /*version*/       1, 0,
  /*title*/         "tcp backboor server (local ip)",
  /*french title*/  "server tcp backdoor (ip locale)",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "server_name server_port",
  /*french usage*/  "nom_serveur port_serveur",
  /*usage example*/ "1.2.3.4 5566",
  /*fr. usage ex.*/ "1.2.3.4 5566",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000216_main(int argc, char *argv[]);
int lcrzoex_000216_msg(lcrzo_sock *psock,
		       lcrzo_conststring errorcode,
		       lcrzo_bool follow,
		       lcrzo_conststring frmsg,
		       lcrzo_conststring usmsg);
int lcrzoex_000216_mustbeauth(lcrzo_sock *psock,
			      lcrzo_conststring command);
int lcrzoex_000216_server(lcrzo_sock sock, void *pinfos);
int lcrzoex_000216_help(lcrzo_sock *psock, 
			lcrzo_bool isauthenticated,
			lcrzo_conststring parameters);
int lcrzoex_000216_auth(lcrzo_sock *psock, 
			lcrzo_bool *pisauthenticated,
			lcrzo_conststring parameters,
			lcrzo_conststring serverrand);
int lcrzoex_000216_exec(lcrzo_sock *psock, 
			lcrzo_bool isauthenticated,
			lcrzo_conststring parameters);
int lcrzoex_000216_get(lcrzo_sock *psock, 
		       lcrzo_bool isauthenticated,
		       lcrzo_conststring parameters);
int lcrzoex_000216_put(lcrzo_sock *psock, 
		       lcrzo_bool isauthenticated,
		       lcrzo_conststring parameters);

/*-------------------------------------------------------------*/
/* error codes */
#define LCRZOEX_000216_ERR_OK            "100"
#define LCRZOEX_000216_ERR_OKBYE         "101"
#define LCRZOEX_000216_ERR_BADLINE       "200"
#define LCRZOEX_000216_ERR_UNSUPCOMMAND  "201"
#define LCRZOEX_000216_ERR_DOUBLEAUTH    "202"
#define LCRZOEX_000216_ERR_NOTAUTH       "203"
#define LCRZOEX_000216_ERR_CANTEXEC      "204"
#define LCRZOEX_000216_ERR_CANTGET       "205"
#define LCRZOEX_000216_ERR_CANTWRITE     "206"
#define LCRZOEX_000216_ERR_BADAUTH       "207"

/*-------------------------------------------------------------*/
/* password : you may change it */
#define LCRZOEX_000216_PASSWORD "lcrzoex"

/*-------------------------------------------------------------*/
/* timeout for reading from socket, in seconds */
#define LCRZOEX_000216_TIMEOUT_COM 60
#define LCRZOEX_000216_TIMEOUT_PUT 10


/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000216_main(int argc, char *argv[])
{ lcrzo_ipl serveripl;
  lcrzo_uint16 serverport;

  if ( argc<3 )
  { /* print usage */
    lcrzo_epr(lcrzoex_infos_print(lcrzoex_000216, argv[0]));
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }

  /* initialize IP address */
  lcrzo_epr(lcrzo_ipl_init_hs(argv[1], &serveripl));

  /* initialize port numbers */
  serverport=(lcrzo_uint16)atoi(argv[2]);

  /* initialize the socket */
  lcrzo_epr(lcrzo_sock_tcpmulser_real2(serveripl, serverport, NULL, 0,
				       &lcrzoex_000216_server, NULL));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000216_msg(lcrzo_sock *psock,
		       lcrzo_conststring errorcode,
		       lcrzo_bool follow,
		       lcrzo_conststring frmsg,
		       lcrzo_conststring usmsg)
{ lcrzo_data data;
  lcrzo_int32 datasize;
  int language;

  lcrzo_epr(lcrzo_global_get_language(&language));

  lcrzo_epr(lcrzo_data_initm_text(errorcode, &data, &datasize));
  if (follow)
  { lcrzo_epr(lcrzo_data_appendm_char('-', 1, datasize, &data, &datasize));
  }
  else
  { lcrzo_epr(lcrzo_data_appendm_char(' ', 1, datasize, &data, &datasize));
  }

  if ( language==LCRZO_GLOBAL_FRLANG )
  { lcrzo_epr(lcrzo_data_appendm_text(frmsg, datasize, &data, &datasize));
  }
  else
  { lcrzo_epr(lcrzo_data_appendm_text(usmsg, datasize, &data, &datasize));
  }
  lcrzo_epr(lcrzo_data_appendm_text("\n", datasize, &data, &datasize));

  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free(data));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000216_mustbeauth(lcrzo_sock *psock,
			      lcrzo_conststring command)
{ lcrzo_data data;
  lcrzo_int32 datasize;
  int language;

  lcrzo_epr(lcrzo_global_get_language(&language));

  if ( language==LCRZO_GLOBAL_FRLANG )
  { lcrzo_epr(lcrzo_data_initm_text(LCRZOEX_000216_ERR_NOTAUTH
				   " il faut etre authentifie pour employer ", 
				    &data, &datasize));
  }
  else
  { lcrzo_epr(lcrzo_data_initm_text(LCRZOEX_000216_ERR_NOTAUTH
				    " must be authenticated to use ", 
				    &data, &datasize));
  }
  lcrzo_epr(lcrzo_data_appendm_text(command, datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text("\n", datasize, &data, &datasize));

  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free(data));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000216_server(lcrzo_sock sock, void *pinfos)
{ lcrzo_data data;
  lcrzo_int32 datasize;
  lcrzo_string command, parameters, serverrand;
  lcrzo_regexp re;
  lcrzo_bool isauthenticated;
  int ret, language;

  /* get language for messages */
  lcrzo_epr(lcrzo_global_get_language(&language));

  /* initilialize server rand */
  lcrzo_epr(lcrzo_string_initm_rand(33, 126, 16, &serverrand));

  /* print the banner */
  lcrzo_epr(lcrzo_data_initm_text(LCRZOEX_000216_ERR_OK " ", 
				  &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(serverrand, datasize, &data, &datasize));
  if ( language==LCRZO_GLOBAL_FRLANG )
  { lcrzo_epr(lcrzo_data_appendm_text(" (utilisez le client special)\n",
				      datasize, &data, &datasize));
  }
  else
  { lcrzo_epr(lcrzo_data_appendm_text(" (use the special client)\n",
				      datasize, &data, &datasize));
  }
  lcrzo_epr(lcrzo_sock_write(&sock, data, datasize));
  lcrzo_epr(lcrzo_data_free(data));

  isauthenticated=LCRZO_FALSE;
  while(1) {
    /* read a line */
    lcrzo_epr(shared_misc_rearmtimer(LCRZOEX_000216_TIMEOUT_COM));
    lcrzo_epr(lcrzo_sock_readm_line(&sock, LCRZO_TRUE, &data, &datasize));
    lcrzo_epr(shared_misc_rearmtimer(0));
    /* ignore empty lines */
    if (datasize==0)
    { lcrzo_data_free(data);
      continue;
    }
    /* print the read data */
    /*lcrzo_epr(lcrzo_data_print(data, datasize, LCRZO_PRINTTYPE_DUMP));*/
    /* separate command and parameters */
    ret=lcrzo_data_search_regexp(data, datasize, LCRZO_FALSE, +1, -1,
				 "^[ \t]*([A-Za-z]+)[ \t]*(.*)[ \t]*$", re);
    if ( ret!=LCRZO_ERR_OK )
    { /* unrecognized command */
      lcrzo_data_free(data);
      lcrzo_epr(lcrzoex_000216_msg(&sock, LCRZOEX_000216_ERR_BADLINE,
				   LCRZO_TRUE, 
                "la ligne n'a pas la forme \"commande [parametres]\"",
		"the line hasn't the format \"command [parameters]\""));
      lcrzo_epr(lcrzoex_000216_msg(&sock, LCRZOEX_000216_ERR_BADLINE,
				   LCRZO_FALSE, 
				   "entrez \"HELP\" pour l'aide",
				   "enter \"HELP\" for help"));
      continue;
    }
    /* set command and parameters */
    data[datasize]='\0';
    lcrzo_epr(lcrzo_string_initm_range(data, re[1].startindex_positive,
				       re[1].endindex_positive, &command));
    if ( re[1].startindex_positive==0 && re[1].endindex_positive==0 )
    { lcrzo_epr(lcrzo_string_initm_text("", &parameters));
    }
    else
    { lcrzo_epr(lcrzo_string_initm_range(data, re[2].startindex_positive,
					 re[2].endindex_positive,&parameters));
    }
    lcrzo_data_free(data);
    /* call functions corresponding to commands */
    /* if we read 'QUIT', we exit */
    if ( ! strcasecmp(command, "quit") ) 
    { lcrzo_epr(lcrzoex_000216_msg(&sock, LCRZOEX_000216_ERR_OKBYE,
				   LCRZO_FALSE, "au revoir", "bye"));
      break;
    }
    /* if we read 'HELP', we print usage */
    else if ( ! strcasecmp(command, "help") )
    { lcrzo_epr(lcrzoex_000216_help(&sock, isauthenticated, parameters));
    }
    /* if we read 'AUTH', we authenticate */
    else if ( ! strcasecmp(command, "auth") )
    { lcrzo_epr(lcrzoex_000216_auth(&sock, &isauthenticated, parameters, 
				    serverrand));
    }
    /* if we read 'EXEC', we execute a command */
    else if ( ! strcasecmp(command, "exec") )
    { lcrzo_epr(lcrzoex_000216_exec(&sock, isauthenticated, parameters));
    }
    /* if we read 'GET', we get a file */
    else if ( ! strcasecmp(command, "get") )
    { lcrzo_epr(lcrzoex_000216_get(&sock, isauthenticated, parameters));
    }
    /* if we read 'PUT', we put a file */
    else if ( ! strcasecmp(command, "put") )
    { lcrzo_epr(lcrzoex_000216_put(&sock, isauthenticated, parameters));
    }
    /* unknown command */
    else
    { if ( language==LCRZO_GLOBAL_FRLANG )
      { lcrzo_epr(lcrzo_data_initm_text(LCRZOEX_000216_ERR_UNSUPCOMMAND
					"-la commande ", &data,&datasize)); 
        lcrzo_epr(lcrzo_data_appendm_text(command, datasize, &data,&datasize));
        lcrzo_epr(lcrzo_data_appendm_text(" est non supportee\n",
					  datasize, &data, &datasize));
        lcrzo_epr(lcrzo_data_appendm_text(LCRZOEX_000216_ERR_UNSUPCOMMAND
					  " entrez \"HELP\" pour l'aide\n",
					  datasize, &data, &datasize)); 
       }
      else
      { lcrzo_epr(lcrzo_data_initm_text(LCRZOEX_000216_ERR_UNSUPCOMMAND
					"-the command ", &data,&datasize)); 
        lcrzo_epr(lcrzo_data_appendm_text(command, datasize, &data,&datasize));
        lcrzo_epr(lcrzo_data_appendm_text(" isn't supported\n",
					  datasize, &data, &datasize));
        lcrzo_epr(lcrzo_data_appendm_text(LCRZOEX_000216_ERR_UNSUPCOMMAND
					  " enter \"HELP\" for help\n",
					  datasize, &data, &datasize)); 
      }
      lcrzo_epr(lcrzo_sock_write(&sock, data, datasize));
      lcrzo_epr(lcrzo_data_free(data));
    }
 
    lcrzo_string_free(command);
    lcrzo_string_free(parameters);    
  }
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000216_help(lcrzo_sock *psock,
			lcrzo_bool isauthenticated,
			lcrzo_conststring parameters)
{
  /* print help */
  lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_OK,
			       LCRZO_TRUE,
	 "Utilisez le client special, car celui-ci comprend ces commandes",
	 "Use the special client, because it understand these commands"));
  lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_OK,
			       LCRZO_TRUE,
			       "HELP : affiche l'aide",
			       "HELP : display this help"));
  lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_OK,
			       LCRZO_TRUE,
         "AUTH aaaaaaaaaa : s'authentifie (utiliser le client special)",
         "AUTH aaaaaaaaaa : authentify (use the special client)"));
  lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_OK,
			       LCRZO_TRUE,
			       "GET fichier : telecharge fichier",
			       "GET file : download file"));
  lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_OK,
			       LCRZO_TRUE,
			       "PUT fichier : uploade fichier",
			       "PUT file : upload file"));
  lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_OK,
			       LCRZO_TRUE,
			       "EXEC commande : execute la commande",
			       "EXEC command : execute the command"));
  lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_OK,
			       LCRZO_FALSE,
			       "QUIT : quitte",
			       "QUIT : leave"));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000216_auth(lcrzo_sock *psock,
			lcrzo_bool *pisauthenticated,
			lcrzo_conststring parameters,
			lcrzo_conststring serverrand)
{ lcrzo_regexp re;
  lcrzo_string clientrand, receivedhash, computedhash;
  int language, ret;

  /* get language for messages */
  lcrzo_epr(lcrzo_global_get_language(&language));

  /* already authenticated */
  if (*pisauthenticated)
  { lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_DOUBLEAUTH,
				 LCRZO_FALSE,
				 "deja authentifie",
				 "already authenticated"));
    return(LCRZO_ERR_OK);
  }

  /* read credentials */
  ret=lcrzo_string_search_regexp(parameters, LCRZO_FALSE, +1, -1,
				 "^(................) "
				 "(........................................)$",
				 re);
  if ( ret!=LCRZO_ERR_OK )
  { /* unrecognized credentials */
    lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_BADAUTH,
				 LCRZO_FALSE,
				 "auth mal formatee", "auth badly formated"));
    return(LCRZOEX_ERR_MISC_BADRESPONSE);
  }
  lcrzo_epr(lcrzo_string_initm_range(parameters, re[1].startindex_positive,
				     re[1].endindex_positive, &clientrand));
  lcrzo_epr(lcrzo_string_initm_range(parameters, re[2].startindex_positive,
				     re[2].endindex_positive, &receivedhash));

  /* compute wanted credentials */
  lcrzo_epr(shared_misc_randpasshash(serverrand, clientrand, 
				     LCRZOEX_000216_PASSWORD, 
				     &computedhash));

  /* verify credentials */
  if ( strcmp(receivedhash, computedhash) )
  { /* unrecognized credentials */
    lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_BADAUTH,
				 LCRZO_FALSE,
				 "mauvais mot de passe", "bad password"));
    return(LCRZOEX_ERR_MISC_BADRESPONSE);
  }
  else
  { /* succesfull authentication */
    lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_OK,
				 LCRZO_FALSE,
				 "OK", "OK"));
    *pisauthenticated=LCRZO_TRUE;
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000216_exec(lcrzo_sock *psock,
			lcrzo_bool isauthenticated,
			lcrzo_conststring parameters)
{ lcrzo_data data, output;
  lcrzo_int32 datasize, outputsize;
  FILE *pf;
  int language, ret;

  /* must be authenticated */
  if (!isauthenticated)
  { lcrzo_epr(lcrzoex_000216_mustbeauth(psock, "EXEC"));
    return(LCRZO_ERR_OK);
  }

  /* get language for messages */
  lcrzo_epr(lcrzo_global_get_language(&language));

  /* execute the given command */
  pf=popen(parameters, "r");
  if (pf==NULL)
  { lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_CANTEXEC,
				 LCRZO_FALSE,
				 "ne peut pas executer cette commande",
				 "could not execute this command"));
    return(LCRZO_ERR_OK);
  }

  /* read all data */
  lcrzo_epr(lcrzo_data_initm_text("", &output, &outputsize));
  while ( lcrzo_stream_readm(pf, LCRZO_TRUE, &data, &datasize)
	  == LCRZO_ERR_OK ) 
  { lcrzo_epr(lcrzo_data_appendm_data(data, datasize, 
				      outputsize, &output, &outputsize));
    lcrzo_data_free(data);
  }

  /* write error code and size */
  ret=pclose(pf);
  lcrzo_epr(lcrzo_data_initm_text(LCRZOEX_000216_ERR_OK, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(" ", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_int(outputsize, "%d",datasize,&data,&datasize));
  lcrzo_epr(lcrzo_data_appendm_text(" ", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_int(ret, "%d", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text("\n", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free(data));
    
  /* write data */
  lcrzo_epr(lcrzo_sock_write(psock, output, outputsize));
  lcrzo_epr(lcrzo_data_free(output));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000216_get(lcrzo_sock *psock,
		       lcrzo_bool isauthenticated,
		       lcrzo_conststring parameters)
{ lcrzo_data data;
  lcrzo_int32 datasize, filesize;
  int ret, fd;

  /* must be authenticated */
  if (!isauthenticated)
  { lcrzo_epr(lcrzoex_000216_mustbeauth(psock, "GET"));
    return(LCRZO_ERR_OK);
  }

  /* open the file */
  ret=lcrzo_fd_open_read(parameters, &fd);
  if (ret!=LCRZO_ERR_OK)
  { lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_CANTGET,
				 LCRZO_FALSE,
				 "ne peut pas lire ce fichier",
				 "could not read this file"));
    return(LCRZO_ERR_OK);
  }
 
  /* write the size of the file */
  lcrzo_epr(lcrzo_fd_size(fd, &filesize));
  lcrzo_epr(lcrzo_data_initm_text(LCRZOEX_000216_ERR_OK, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(" ", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_int(filesize, "%d",datasize,&data,&datasize));
  lcrzo_epr(lcrzo_data_appendm_text("\n", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free(data));

  /* write file data */ 
  while ( lcrzo_fd_readm(fd, LCRZO_TRUE, &data, &datasize)
	  == LCRZO_ERR_OK ) 
  { lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
    lcrzo_data_free(data);
  }
  lcrzo_epr(lcrzo_fd_close(fd));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000216_put(lcrzo_sock *psock,
		       lcrzo_bool isauthenticated,
		       lcrzo_conststring parameters)
{ lcrzo_data data;
  lcrzo_int32 datasize, filesize, bytetoread;
  lcrzo_bool errorinopen, errorinread;
  int ret, fd;

  /* must be authenticated */
  if (!isauthenticated)
  { lcrzo_epr(lcrzoex_000216_mustbeauth(psock, "PUT"));
    return(LCRZO_ERR_OK);
  }

  /* get the size to read */
  lcrzo_epr(shared_misc_rearmtimer(LCRZOEX_000216_TIMEOUT_PUT));
  lcrzo_epr(lcrzo_sock_readm_line(psock, LCRZO_TRUE, &data, &datasize));
  lcrzo_epr(shared_misc_rearmtimer(0));
  data[datasize]='\0';
  lcrzo_er(lcrzo_int32_init_text(data, &filesize));
  lcrzo_epr(lcrzo_data_free(data));

  errorinopen=LCRZO_FALSE;
  errorinread=LCRZO_FALSE;
  /* open the file */
  ret=lcrzo_fd_open_write(parameters, LCRZO_FALSE, LCRZO_FALSE, &fd);
  if (ret!=LCRZO_ERR_OK)
  { errorinopen=LCRZO_TRUE;
  }

  /* read filesize bytes, and put them in the file (if no error) */
  bytetoread=filesize;
  while (bytetoread)
  { lcrzo_epr(shared_misc_rearmtimer(LCRZOEX_000216_TIMEOUT_PUT));
    lcrzo_epr(lcrzo_sock_readm(psock, LCRZO_TRUE, &data, &datasize));
    if (!errorinopen)
    { lcrzo_epr(lcrzo_fd_write(fd, data, datasize));
    }
    lcrzo_epr(lcrzo_data_free(data));
    if (datasize>bytetoread)
    { /* the client sent too much */
      errorinread=LCRZO_TRUE;
      break;
    }
    bytetoread-=datasize;
  }
  if (!errorinopen)
  { lcrzo_epr(lcrzo_fd_close(fd));
  }

  /* write message */
  if ( errorinopen )
  { lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_CANTWRITE,
				 LCRZO_FALSE,
				 "ne peut pas ecrire ce fichier",
				 "could not write this file"));
  }
  else if ( errorinread )
  { lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_CANTWRITE,
				 LCRZO_FALSE,
				 "lu trop de caracteres",
				 "read too much bytes"));
  }
  else
  { lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_OK,
				 LCRZO_FALSE,
				 "OK", "OK"));
  }
  return(LCRZO_ERR_OK);
}

