#ifndef LCRZOEX_HTTP_INCLUDED
#define LCRZOEX_HTTP_INCLUDED 1
#include "shared_error.h"

int shared_http_initm_methurlhttpver(lcrzo_conststring method,
				     lcrzo_conststring url,
				     lcrzo_conststring version,
				     lcrzo_data *pdata,
				     lcrzo_int32 *pdatasize);

int shared_http_appendm_hostport(lcrzo_conststring hostname,
				 lcrzo_uint16 port,
				 lcrzo_int32 datacurrentsize,
				 lcrzo_data *pdata,
				 lcrzo_int32 *pdatasize);

int shared_http_appendm_ipport(lcrzo_ipl ip,
			       lcrzo_uint16 port,
			       lcrzo_int32 datacurrentsize,
			       lcrzo_data *pdata,
			       lcrzo_int32 *pdatasize);

int shared_http_appendm_authbasiclogpass(lcrzo_conststring login,
					 lcrzo_conststring passwd,
					 lcrzo_int32 datacurrentsize,
					 lcrzo_data *pdata,
					 lcrzo_int32 *pdatasize);

int shared_http_percenttext_initm_data(lcrzo_constdata data,
				       lcrzo_int32 datasize,
				       lcrzo_string *ptextwithpercent);

int shared_http_data_initm_percenttext(lcrzo_conststring textwithpercent,
				       lcrzo_data *pdata,
				       lcrzo_int32 *pdatasize);


int shared_http_request_get(lcrzo_sock *psock,
			    lcrzo_conststring url,
			    lcrzo_conststring hostname,
			    lcrzo_uint16 port,
			    lcrzo_conststring login,
			    lcrzo_conststring passwd);

int shared_http_request_post(lcrzo_sock *psock,
			     lcrzo_conststring url,
			     lcrzo_conststring hostname,
			     lcrzo_uint16 port,
			     lcrzo_conststring login,
			     lcrzo_conststring passwd,
			     lcrzo_conststring parameters);

int shared_http_request_head(lcrzo_sock *psock,
			     lcrzo_conststring url,
			     lcrzo_conststring hostname,
			     lcrzo_uint16 port,
			     lcrzo_conststring login,
			     lcrzo_conststring passwd);

int shared_http_request_put(lcrzo_sock *psock,
			    lcrzo_conststring url,
			    lcrzo_conststring hostname,
			    lcrzo_uint16 port,
			    lcrzo_conststring login,
			    lcrzo_conststring passwd,
			    lcrzo_data filedata,
			    lcrzo_int32 filedatasize);

int shared_http_request_delete(lcrzo_sock *psock,
			       lcrzo_conststring url,
			       lcrzo_conststring hostname,
			       lcrzo_uint16 port,
			       lcrzo_conststring login,
			       lcrzo_conststring passwd);

int shared_http_response_readheader(lcrzo_sock *psock,
				    lcrzo_int16 *perrornumber,
				    lcrzo_string *perrormsg,
				    lcrzo_string *pservertype,
				    lcrzo_string *pcontenttype,
				    lcrzo_int32 *pcontentlenght,
				    lcrzo_data *pheader,
				    lcrzo_int32 *pheadersize);

int shared_http_response_readbody(lcrzo_sock *psock,
				  lcrzo_int32 contentlength,
				  lcrzo_data *pbody,
				  lcrzo_int32 *pbodysize);

#endif
