#include <lcrzo.h>
#include "../lcrzoex.h"
#include "shared_misc.h"

/*-------------------------------------------------------------*/
int shared_misc_dangerousexample(void)
{ lcrzo_uint8 c;
  int language;

  lcrzo_epr(lcrzo_global_get_language(&language));

  if ( language==LCRZO_GLOBAL_FRLANG )
  { puts("Ceci va perturber le fonctionnement de tout le reseau.");
    lcrzo_epr(lcrzo_stdin_char("Voulez-vous reellement continuer ?",
			       (const lcrzo_uint8*)"oOnN", 'n', &c));
  }
  else
  { puts("This example will disturb your network.");
    lcrzo_epr(lcrzo_stdin_char("Do you really want to continue ?",
			       (const lcrzo_uint8*)"yYnN", 'n', &c));
  }
  if (c=='n' || c=='N') exit(LCRZO_ERR_OK);
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_misc_verifyresponse(lcrzo_sock *psock, 
			       lcrzo_uint16 error1, 
			       lcrzo_uint16 error2, 
			       lcrzo_uint16 error3, 
			       lcrzo_uint16 error4,
			       lcrzo_bool displayerrors,
			       lcrzo_uint16 *preaderror,
			       lcrzo_data *preaddata,
			       lcrzo_int32 *preaddatasize)
{ lcrzo_data data, readdata;
  lcrzo_int32 datasize, readdatasize;
  lcrzo_uint16 readerror;
  lcrzo_string errorlist;
  lcrzo_bool notenough;
  int language, ret;

  /* read response from the socket */
  notenough=LCRZO_TRUE;
  readerror=0; /*just for the compiler*/
  lcrzo_epr(lcrzo_data_initm_text("", &readdata, &readdatasize));
  while (notenough)
  { /* read a line */
    lcrzo_epr(lcrzo_sock_readm_line(psock, LCRZO_TRUE, &data, &datasize));
    /* append data in readdata */
    if ( datasize>=4 )
    { /* if data is "    YYYY" we save only YYYY, an continue */
      if ( data[0]==' ' && data[1]==' ' && data[2]==' ' && data[3]==' ' )
      { lcrzo_epr(lcrzo_data_appendm_data(data+4, datasize-4, readdatasize, 
					  &readdata, &readdatasize));
      }   
      /* if data is "xxx.YYYY" we save only YYYY */
      else if ( isdigit(data[0]) && isdigit(data[1]) && isdigit(data[2]) )
      { lcrzo_epr(lcrzo_data_appendm_data(data+4, datasize-4, readdatasize, 
					  &readdata, &readdatasize));
        /* if data is "xxx YYYY" there is no more line to read */
        if ( data[3]==' ' ) 
	{ notenough=LCRZO_FALSE;
	  data[3]='\0';
	  readerror=atoi(data);
	}
      }
      /* else, we append the entire line */
      else
      { lcrzo_epr(lcrzo_data_appendm_data(data, datasize, readdatasize, 
					  &readdata, &readdatasize));
      }
      /* separate each line by a newline */
      lcrzo_epr(lcrzo_data_appendm_text("\n", readdatasize, 
					&readdata, &readdatasize));
    }
    lcrzo_data_free(data);
  }

  /* verify error */
  if ( readerror!=error1 && readerror!=error2 &&
       readerror!=error3 && readerror!=error4 )
  { if (displayerrors)
    { /* prepare error string */
      lcrzo_epr(lcrzo_string_initm_int(error1, "%d", &errorlist));
      if ( error2 != error1 )
      { lcrzo_epr(lcrzo_string_appendm_char('-', 1, &errorlist));
        lcrzo_epr(lcrzo_string_appendm_int(error2, "%d", &errorlist));
        if ( error3 != error2 )
        { lcrzo_epr(lcrzo_string_appendm_char('-', 1, &errorlist));
   	  lcrzo_epr(lcrzo_string_appendm_int(error3, "%d", &errorlist));
	  if ( error4 != error3 )
	  { lcrzo_epr(lcrzo_string_appendm_char('-', 1, &errorlist));
	    lcrzo_epr(lcrzo_string_appendm_int(error4, "%d", &errorlist));
	  }
	}
      }
      /* print message */
      lcrzo_epr(lcrzo_global_get_language(&language));
      if ( language==LCRZO_GLOBAL_FRLANG )
	printf("Je voulais %s, mais j'ai recu %d\n", errorlist, readerror); 
      else
	printf("I wanted %s, but I received %d\n", errorlist, readerror); 
      lcrzo_epr(lcrzo_data_print(readdata, readdatasize,LCRZO_PRINTTYPE_DUMP));
      lcrzo_string_free(errorlist);
    }
    ret=LCRZOEX_ERR_MISC_BADRESPONSE;
  }
  else
    ret=LCRZO_ERR_OK;

  /* set output */
  if (preaderror!=NULL) *preaderror=readerror;
  if (preaddatasize!=NULL) *preaddatasize=readdatasize;
  if (preaddata!=NULL)
  { *preaddata=readdata;
  }
  else
  { lcrzo_data_free(readdata);
  }

  return(ret);
}

/*-------------------------------------------------------------*/
int shared_misc_verifyresponse1(lcrzo_sock *psock, 
				lcrzo_uint16 error)
{ return(shared_misc_verifyresponse(psock, error, error, error, error,
				    LCRZO_TRUE, NULL, NULL, NULL));
}

/*-------------------------------------------------------------*/
int shared_misc_verifyresponse2(lcrzo_sock *psock, 
				lcrzo_uint16 error1, 
				lcrzo_uint16 error2)
{ return(shared_misc_verifyresponse(psock, error1, error2, error2, error2,
				    LCRZO_TRUE, NULL, NULL, NULL));
}

/*-------------------------------------------------------------*/
int shared_misc_verifyresponse3(lcrzo_sock *psock, 
				lcrzo_uint16 error1, 
				lcrzo_uint16 error2, 
				lcrzo_uint16 error3)
{ return(shared_misc_verifyresponse(psock, error1, error2, error3, error3,
				    LCRZO_TRUE, NULL, NULL, NULL));
}

/*-------------------------------------------------------------*/
int shared_misc_verifyresponse4(lcrzo_sock *psock, 
				lcrzo_uint16 error1, 
				lcrzo_uint16 error2, 
				lcrzo_uint16 error3, 
				lcrzo_uint16 error4)
{ return(shared_misc_verifyresponse(psock, error1, error2, error3, error4,
				    LCRZO_TRUE, NULL, NULL, NULL));
}


/*-------------------------------------------------------------*/
int shared_misc_printnumberbase(char *string, int base)
{ lcrzo_uint32 i;
  char *p;
  int language;

  lcrzo_epr(lcrzo_global_get_language(&language));
  errno=0;
  i=strtoul(string, &p, base);
  if (*p!='\0')
  { if ( language==LCRZO_GLOBAL_FRLANG )
      printf("Le nombre %s n'est pas en base %d\n", string, base);
    else
      printf("The number %s is not in base %d\n", string, base);
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }
  if ( errno==ERANGE ) 
  { if ( language==LCRZO_GLOBAL_FRLANG )
      printf("Le nombre %s en base %d est trop long\n", string, base);
    else
      printf("The number %s in base %d is too long\n", string, base);
    return(LCRZO_ERR_BULCRZOEXBADUSAGE);
  }

  lcrzo_epr(shared_misc_printnumber(i));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_misc_printnumber(lcrzo_uint32 number)
{ lcrzo_uint32 i, n, print;
  lcrzo_ipa ipa;
  int language;

  lcrzo_epr(lcrzo_global_get_language(&language));

  /* binary */
  if ( language==LCRZO_GLOBAL_FRLANG )
    printf("Binaire        : ");
  else
    printf("Binary         : ");
  print=0;
  for ( i=31 ; i>0 ; i-- )
  { n=(number>>i)&1;
    if (print)
    { if ( !((i+1)%4) ) printf(" ");
      printf("%c", (n==0)?'0':'1');
    }
    else
    { if (n==1)
      { print=1;
        printf("1");
      }
    }
  }
  printf("%c\n", (number&1)?'1':'0');

  /* octal */
  printf("Octal          : %lo\n", number);

  /* decimal */
  printf("Decimal        : %lu\n", number);
  if (number<=0xFFFF)
    printf("Decimal 16n    : %u\n", lcrzo_htons(number));
  printf("Decimal 32n    : %lu\n", lcrzo_htonl(number));

  /* hexadecimal */
  printf("Hexa           : %lX\n", number);
  if (number<=0xFFFF)
    printf("Hexa 16n       : %X\n", lcrzo_htons(number));
  printf("Hexa 32n       : %lX\n", lcrzo_htonl(number));

  /* character */
  if ( number<=255 )
  { if ( language==LCRZO_GLOBAL_FRLANG )
      printf("Caractere      : ");
    else
      printf("Character      : ");
    printf("%c\n", (char)number);
  }
  if ( number<=0xFFFF && lcrzo_htons(number)<=255 )
  { if ( language==LCRZO_GLOBAL_FRLANG )
      printf("Caractere 16n  : ");
    else
      printf("Character 16n  : ");
    printf("%c\n", (char)lcrzo_htons(number));
  }
  if ( lcrzo_htonl(number)<=255 )
  { if ( language==LCRZO_GLOBAL_FRLANG )
      printf("Caractere 32n  : ");
    else
      printf("Character 32n  : ");
    printf("%c\n", (char)lcrzo_htonl(number));
  }

  /* IP address */
  lcrzo_epr(lcrzo_ipa_init_ipl(number, ipa));
  if ( language==LCRZO_GLOBAL_FRLANG )
    printf("Adresse IP     : ");
  else
    printf("IP address     : ");
  printf("%d.%d.%d.%d\n", 
	 (unsigned int)ipa[0], (unsigned int)ipa[1],
	 (unsigned int)ipa[2], (unsigned int)ipa[3]);
  if ( language==LCRZO_GLOBAL_FRLANG )
    printf("Adresse IP 32n : ");
  else
    printf("IP address 32n : ");
  printf("%d.%d.%d.%d\n",
	 (unsigned int)ipa[3], (unsigned int)ipa[2],
	 (unsigned int)ipa[1], (unsigned int)ipa[0]);

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_misc_printdata(lcrzo_data data, lcrzo_int32 datasize)
{ int language;

  lcrzo_epr(lcrzo_global_get_language(&language));

  if ( language==LCRZO_GLOBAL_FRLANG )
    printf("***********Texte affichable :\n");
  else
    printf("***********Printable text :\n");
  lcrzo_epr(lcrzo_data_print(data, datasize, LCRZO_PRINTTYPE_PTEXTN));

  printf("***********Dump :\n");
  lcrzo_epr(lcrzo_data_print(data, datasize, LCRZO_PRINTTYPE_DUMP));

  printf("***********Hexadecimal :\n");
  lcrzo_epr(lcrzo_data_print(data, datasize, LCRZO_PRINTTYPE_HEXAN));

  if ( language==LCRZO_GLOBAL_FRLANG )
    printf("***********Mixte :\n");
  else
    printf("***********Mixed :\n");
  lcrzo_epr(lcrzo_data_print(data, datasize, LCRZO_PRINTTYPE_MIXEDN));

  printf("***********Base 64 :\n");
  lcrzo_epr(lcrzo_data_print(data, datasize, LCRZO_PRINTTYPE_BASE64N));
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_misc_rearmtimer(lcrzo_int32 seconds)
{ alarm(seconds);
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_misc_randpasshash(lcrzo_conststring serverrand, 
			     lcrzo_conststring clientrand,
			     lcrzo_conststring password,
			     lcrzo_string *phash)
{ lcrzo_uint8 pass[17];
  lcrzo_uint32 arr[12];
  lcrzo_uint32 A, B, C, D, E;
  int i;

  if (strlen(serverrand)!=16) return(LCRZOEX_ERR_MISC_HASHBADSIZE);
  if (strlen(clientrand)!=16) return(LCRZOEX_ERR_MISC_HASHBADSIZE);

  /* generate a 16 bytes long password */
  for ( i=0 ; i<16 ; i++ )  
  { if ( i>=strlen(password) ) pass[i]=' ';
    else pass[i]=password[i];
  }
  pass[16]='\0';

  /* generate the array of 3*16=3*4*4=12*4 bytes */
  #define SHARED_MISC_ARR(x) (((x)[0]<<24)|((x)[1]<<16)|((x)[2]<<8)|(x)[3])
  for ( i=0 ; i<4 ; i++ )  
  { arr[i]=SHARED_MISC_ARR(serverrand+(i<<2));
    arr[4+i]=SHARED_MISC_ARR(pass+(i<<2));
    arr[8+i]=SHARED_MISC_ARR(clientrand+(i<<2));
  }

  /* compute the hash. We should use md5, but I do not want to 
     oblige users to install a md5 library */
  #define SHARED_MISC_F1(x,y,z)  ( (z) ^ ( (x) & ( (y) ^ (z) ) ) )
  #define SHARED_MISC_F2(x,y,z)  ( (x) ^ (y) ^ (z) )
  #define SHARED_MISC_F3(x,y,z)  ( ( (x) & (y) ) | ( (z) & ( (x) | (y) ) ) )
  #define SHARED_MISC_F4(x,y,z)  ( (x) ^ (y) ^ (z) )
  #define SHARED_MISC_ROTL(n,X)  ( ( ( X ) << n ) | ( ( X ) >> ( 32 - n ) ) )
  #define SHARED_MISC_FF(a, b, c, d, e, f, k, data) \
    ( e += SHARED_MISC_ROTL( 5, a ) + f( b, c, d ) + k + data, \
      b = SHARED_MISC_ROTL( 30, b ) )
  A=0x4B2A71C8u; B=0x81CA93B6u; C=0xBD61ADC9u; D=0x492D16CAu; E=0xBD72C9A1u;
  SHARED_MISC_FF( A, B, C, D, E, SHARED_MISC_F1, 0x381C3A72u, arr[0]);
  SHARED_MISC_FF( E, A, B, C, D, SHARED_MISC_F2, 0xC51A85BFu, arr[1] );
  SHARED_MISC_FF( E, A, B, C, D, SHARED_MISC_F1, 0xC714A7B3u, arr[2] );
  SHARED_MISC_FF( D, E, A, B, C, SHARED_MISC_F4, 0x2934C1AEu, arr[3] );
  SHARED_MISC_FF( C, D, E, A, B, SHARED_MISC_F3, 0x31CA83A5u, arr[4] );
  SHARED_MISC_FF( B, C, D, E, A, SHARED_MISC_F2, 0xFE341A94u, arr[5] );
  SHARED_MISC_FF( A, B, C, D, E, SHARED_MISC_F4, 0xFA183B6Au, arr[6] );
  SHARED_MISC_FF( D, C, D, A, E, SHARED_MISC_F1, 0x381C3A72u, arr[7]);
  SHARED_MISC_FF( C, C, A, B, D, SHARED_MISC_F3, 0xDE529753u, arr[8] );
  SHARED_MISC_FF( A, E, C, B, D, SHARED_MISC_F2, 0x69BCDF12u, arr[9] );
  SHARED_MISC_FF( B, D, E, A, C, SHARED_MISC_F1, 0x9CED1864u, arr[10] );
  SHARED_MISC_FF( C, A, B, D, E, SHARED_MISC_F3, 0xBCCD19ADu, arr[11] );
  lcrzo_string_initm_int(A, "%08lX", phash);
  lcrzo_string_appendm_int(B, "%08lX", phash);
  lcrzo_string_appendm_int(C, "%08lX", phash);
  lcrzo_string_appendm_int(D, "%08lX", phash);
  lcrzo_string_appendm_int(E, "%08lX", phash);

  return (LCRZO_ERR_OK);
}


