#include <lcrzo.h>
#include "../lcrzoex.h"
#include "shared_syslog.h"


/*-------------------------------------------------------------*/
int shared_syslog_datehexa(lcrzo_uint8 facilitypriority,
			   lcrzo_conststring username,
			   lcrzo_data *pdata,
			   lcrzo_int32 *pdatasize)
{ lcrzo_data data;
  lcrzo_int32 datasize;
  lcrzo_time currenttime;

  /* initialize the data */
  lcrzo_epr(lcrzo_data_initm_char('<', 1, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_int(facilitypriority, "%d", datasize, 
                                   &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_char('>', 1, datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(username, datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(" was here at ", datasize, 
                                    &data, &datasize));
  lcrzo_epr(lcrzo_time_init(&currenttime));
  lcrzo_epr(lcrzo_data_appendm_int(currenttime.sec, "%08X", datasize, 
                                   &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(".", datasize, 
                                    &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_int(currenttime.usec, "%08X", datasize, 
                                   &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(".", datasize, &data, &datasize));

  /* set the output values */
  if (pdatasize!=NULL) *pdatasize=datasize;
  if (pdata!=NULL)
  { *pdata=data;
  }
  else
  { lcrzo_data_free(data);
  }

  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_syslog_sockdatehexa(lcrzo_sock *psock,
			       lcrzo_uint8 facilitypriority,
			       lcrzo_conststring username)
{ lcrzo_data data;
  lcrzo_int32 datasize;

  /* initialize the data */
  lcrzo_epr(shared_syslog_datehexa(facilitypriority, username,
				   &data, &datasize));

  /* write to the socket */
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free(data));

  return (LCRZO_ERR_OK);
}

